#import "NYXAppDelegate.h"


#define MMG_TEXT @"En effet, l’intégration native de Linkedin a été supprimée, il faudra maintenant passer par un achat in-app (au même titre que Instagram, Foursquare et AngelList) facturée presque 8€, une aberration pour un service gratuit dans les versions précédentes. L’application perd quelques fonctionnalités. Par exemple, avant, chaque contact importé était relié à son compte Facebook, Twitter, etc. Aujourd’hui, ce sont tous les contacts qui sont directement importés depuis les réseaux sociaux. De quoi vite se retrouver face à une énorme liste de contacts inutilisable."


#define VERB_COLOR [NSColor greenColor]
#define NOUN_COLOR [NSColor blueColor]
#define ADVERB_COLOR [NSColor redColor]
#define CONJ_COLOR [NSColor orangeColor]
#define PREP_COLOR [NSColor purpleColor]
#define ADJ_COLOR [NSColor yellowColor]


@implementation NYXAppDelegate

-(void)applicationDidFinishLaunching:(NSNotification*)aNotification
{
	[self updateTextDisplay];
}

-(IBAction)updateTV:(id)sender
{
	[self updateTextDisplay];
}

-(void)updateTextDisplay
{
	[_textView setString:@""];
	NSMutableAttributedString* text = [[NSMutableAttributedString alloc] initWithString:MMG_TEXT];
	[text addAttribute:NSFontAttributeName value:[NSFont fontWithName:@"Courier" size:20.0f] range:(NSRange){0, [MMG_TEXT length]}];
	[text addAttribute:NSForegroundColorAttributeName value:[NSColor blackColor] range:(NSRange){0, [MMG_TEXT length]}];
	
	NSLinguisticTagger* tagger = [[NSLinguisticTagger alloc] initWithTagSchemes:@[NSLinguisticTagSchemeTokenType, NSLinguisticTagSchemeLexicalClass, NSLinguisticTagSchemeNameType] options:0];
	[tagger setString:MMG_TEXT];
	
	[tagger enumerateTagsInRange:(NSRange){0, [MMG_TEXT length]} scheme:NSLinguisticTagSchemeLexicalClass options:0 usingBlock:^(NSString *tag, NSRange tokenRange, NSRange sentenceRange, BOOL *stop) {
		if (tag == NSLinguisticTagNoun && [_swNouns state] == NSOnState)
		{
			[text addAttribute:NSForegroundColorAttributeName value:NOUN_COLOR range:tokenRange];
		}
		if (tag == NSLinguisticTagAdjective && [_swAdjectivs state] == NSOnState)
		{
			[text addAttribute:NSForegroundColorAttributeName value:ADJ_COLOR range:tokenRange];
		}
		if (tag == NSLinguisticTagAdverb && [_swAdverbs state] == NSOnState)
		{
			[text addAttribute:NSForegroundColorAttributeName value:ADVERB_COLOR range:tokenRange];
		}
		if (tag == NSLinguisticTagConjunction && [_swConjunctions state] == NSOnState)
		{
			[text addAttribute:NSForegroundColorAttributeName value:CONJ_COLOR range:tokenRange];
		}
		if (tag == NSLinguisticTagPreposition && [_swPrep state] == NSOnState)
		{
			[text addAttribute:NSForegroundColorAttributeName value:PREP_COLOR range:tokenRange];
		}
		if (tag == NSLinguisticTagVerb && [_swVerbs state] == NSOnState)
		{
			[text addAttribute:NSForegroundColorAttributeName value:VERB_COLOR range:tokenRange];
		}
	}];
	[_textView insertText:text];
}

@end
